/* Stamps
 * The stamp (postage) amount calculator from USA to USA/Canada/Mexico/Japan/others
 *
 * by TERADA, Koichi
 * email: kterada@iname.com
 * web:   http://www04.u-page.so-net.ne.jp/zd5/kterada/
 * July 1998
 */
  
#include <PalmOS.h>
#include <PalmCompatibility.h>
//#include <Pilot.h>
//#include <Common.h>
//#include <System/SysAll.h>
//#include <UI/UIAll.h>

#include "stamps_res.h"
#include "stamps.h"



FieldPtr	fieldptr_text;   // FieldPtr and DmOpenRef are defined in the PalmOS header files.
FieldPtr	fieldptr_hex;	// See if you can find where they are defined.
FieldPtr	fieldptr_total;	// See if you can find where they are defined.
/*
DmOpenRef	StampsDB;
char		StampsDBName[] = "StampsDB";	*/
char		hex[10];
char		convbuf[10];

VoidHand	textHand;
char		*textbuf;
short		checkbox_033;
short		checkbox_050;
short		checkbox_060;
short		checkbox_100;
short		list_unit;
short		list_dest;
short		list_033;
short		list_050;
short		list_060;
short		list_100;
char		totalbuf[20];
short		popup_stamps[] = {1, 2, 5, 10, 21, 23, 24, 25, 34, 37, 39, 40, 45, 48, 55, 57, 60, 70, 76, 80, 100};

DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
  int error;
	
	if (cmd == sysAppLaunchCmdNormalLaunch) {
		error = StartApplication();	// Application start code
		if (error) return error;
		EventLoop();		// Event loop
		StopApplication ();	// Application stop code
	}
	return 0;
}

static int StartApplication(void)
{
/*	int error;
	
	error = OpenDatabase();
	if (error) return error;	*/
	
	textHand = MemHandleNew( TextbufSize );
	if( textHand == 0 ) return 1;
	textbuf = MemHandleLock( textHand );
	StampsLoadPrefs();
	
	FrmGotoForm(StampsForm);
	return 0;
}

static void EventLoop(void)
{
	short err;
	int formID;
	FormPtr form;
	EventType event;
	
	do {
		EvtGetEvent(&event, evtWaitForever);
		
		if (SysHandleEvent(&event)) continue;
		if (MenuHandleEvent((void *)0, &event, (WordPtr)&err)) continue;
		
		if ( event.eType == frmLoadEvent ) {
			formID = event.data.frmLoad.formID;
			form = FrmInitForm(formID);
			FrmSetActiveForm(form);
			switch (formID) {
			case StampsForm:
				FrmSetEventHandler(form, (FormEventHandlerPtr) Stamps);
				break;
			}
		}
		FrmDispatchEvent(&event);
	} while(event.eType != appStopEvent);
}

static void StopApplication(void)
{
/*	VoidHand		RecHandle;
	Ptr				RecPointer;
	char buf[6];	*/
	
	FldSetTextHandle(fieldptr_text, NULL);
	getOptionStatus();
	
	StampsSavePrefs();
	MemHandleUnlock( textHand );
	MemHandleFree( textHand );
}

static void StampsLoadPrefs(void)
{
	SWord prefsVersion;
	StampsPreferenceType prefs;
	Word prefsSize;
	int availPrefs;
	SystemPreferencesType sysPrefs;
	
	PrefGetPreferences( &sysPrefs );	
	
	prefsSize = sizeof (StampsPreferenceType);
	if( sysPrefs.version >= 2 ) {
		prefsVersion = PrefGetAppPreferences( StampsAppID, 0, &prefs, &prefsSize, true );
		availPrefs = ( prefsVersion == StampsPrefVersionNum );
	} else {
		availPrefs = PrefGetAppPreferencesV10( StampsAppID, 0, &prefs, prefsSize );
	}
	
	if( ! availPrefs ) {	// if there is no available prefs
		textbuf[0] = '\0';
		checkbox_033 = checkbox_050 = checkbox_060 =checkbox_100 = 1;
		list_unit = 0;			// Default is "gram"
		list_dest = JAPAN;			// Default is "Japan"
		list_033 = 2;
		list_050 = 3;
		list_060 = 5;
		list_100 = 6;
	} else {
		StrCopy( textbuf, prefs.text );
		checkbox_033 = prefs.checkbox_033;
		checkbox_050 = prefs.checkbox_050;
		checkbox_060 = prefs.checkbox_060;
		checkbox_100 = prefs.checkbox_100;
		list_unit = prefs.list_unit;
		list_dest = prefs.list_dest;
		list_033 = prefs.list_033;
		list_050 = prefs.list_050;
		list_060 = prefs.list_060;
		list_100 = prefs.list_100;
	}
}

static void StampsSavePrefs(void)
{
	StampsPreferenceType prefs;
	SystemPreferencesType sysPrefs;

	PrefGetPreferences( &sysPrefs );	
	
	StrCopy( prefs.text, textbuf );
	prefs.checkbox_033 = checkbox_033;
	prefs.checkbox_050 = checkbox_050;
	prefs.checkbox_060 = checkbox_060;
	prefs.checkbox_100 = checkbox_100;
	prefs.list_unit = list_unit;
	prefs.list_dest = list_dest;
	prefs.list_033 = list_033;
	prefs.list_050 = list_050;
	prefs.list_060 = list_060;
	prefs.list_100 = list_100;
	
	if( sysPrefs.version >= 2 ) {
		PrefSetAppPreferences( StampsAppID, 0, StampsPrefVersionNum, &prefs, 
				sizeof (StampsPreferenceType), true);
	} else {
		PrefSetAppPreferencesV10( StampsAppID, StampsPrefVersionNum, &prefs, 
				sizeof (StampsPreferenceType));
	}
}

void setSelectStampList( short index )
{
	FormPtr form;
	void *objPtr;

	form = FrmGetActiveForm();
	objPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsListOfStampsList));
	LstSetSelection( objPtr, index );
	LstSetTopItem( objPtr, index );
}

static Boolean Stamps(EventPtr event)
{
	FormPtr		form;
	int			handled = 0;
	
	switch (event->eType) {
	case frmOpenEvent:
		form = FrmGetActiveForm();
		fieldptr_text = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_textField));
		FldSetTextHandle( fieldptr_text, textHand );
	/*	FldSetTextHandle (fieldptr_text, (Handle) DmGetRecord(StampsDB, 0));	*/
		fieldptr_hex = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_hexField));
		fieldptr_total = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_totalField));
		
		FrmSetFocus( form, FrmGetObjectIndex(form, stampsFieldID_textField) );
		FldSetSelection( fieldptr_text, 0, StrLen( FldGetTextPtr(fieldptr_text) ));
		setOptionStatus();
		
		FrmDrawForm(form);
		handled = 1;
		break;
		
	case ctlSelectEvent:  // A control button was pressed and released.
		switch( event->data.ctlSelect.controlID ) {
		case stampsButtonID_convertButton:
			Calc();
			handled = 1;
			break;
		case stampsPopup033PopTrigger:
			setSelectStampList( list_033 );
			break;
		case stampsPopup050PopTrigger:
			setSelectStampList( list_050 );
			break;
		case stampsPopup060PopTrigger:
			setSelectStampList( list_060 );
			break;
		case stampsPopup100PopTrigger:
			setSelectStampList( list_100 );
			break;
		}
		break;
	
	case menuEvent:
		switch (event->data.menu.itemID) {
		case CommandCalculate:
			Calc();
			break;
		case CommandAbout:
			FrmAlert(AboutAlert);
			break;
		case EditCopy:
			CopyClipboard();
			/* FldCopy(fieldptr_text); */   // user has to select (highllight) the text to copy
			break;
		case EditPaste:
			FldPaste(fieldptr_text);
			break;
		case EditKeyboard:			// Display the on screen keyboard.
			SysKeyboardDialog(kbdNumbersAndPunc);
			break;
		case EditGraffitiHelp:		// Display the graffiti reference screen
			SysGraffitiReferenceDialog (referenceDefault);
			break;
		}
		handled = 1;
		break;
	
	case keyDownEvent:
		switch( event->data.keyDown.chr ) {
		case pageUpChr:
			Calc();
			handled = 1;
			break;
		case pageDownChr:
			Calc();
			handled = 1;
			break;
		default:
			break;
		}
		break;
	
	case popSelectEvent:
		switch( event->data.popSelect.controlID ) {
		case stampsPopupID_unitPopTrigger:
			list_unit = event->data.popSelect.selection;
			break;
		case stampsPopupID_destPopTrigger:
			list_dest = event->data.popSelect.selection;
			break;
		case stampsPopup033PopTrigger:
			list_033 = event->data.popSelect.selection;
			break;
		case stampsPopup050PopTrigger:
			list_050 = event->data.popSelect.selection;
			break;
		case stampsPopup060PopTrigger:
			list_060 = event->data.popSelect.selection;
			break;
		case stampsPopup100PopTrigger:
			list_100 = event->data.popSelect.selection;
			break;
		}
		//setOptionStatus();
		//FrmDrawForm(FrmGetActiveForm());
		//handled = 1;
		break;

	case nilEvent:
		handled = 1;
		break;
	}
	return handled;
}

static void CopyClipboard(void)
{
	FormPtr		form;
	FieldPtr	fPtr;
	Word		select_begin, select_end;
	
	form = FrmGetActiveForm();
	
	fPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_textField));
	FldGetSelection( fPtr, &select_begin, &select_end );
	if( select_begin != select_end ) {
		FldCopy(fieldptr_text);
		return;
	}
	
	fPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_hexField));
	FldGetSelection( fPtr, &select_begin, &select_end );
	if( select_begin != select_end ) {
		FldCopy(fieldptr_hex);
		return;
	}
	
	fPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_totalField));
	FldGetSelection( fPtr, &select_begin, &select_end );
	if( select_begin != select_end ) {
		FldCopy(fieldptr_total);
		return;
	}
	return;
}

static void Calc(void)
{
	char  textchar;
	int  textpos;
	int  textlength;
	CharPtr  textpointer;
	long int number;
	int weight_oz;
	int amount;
	int pointpos;
	int total_amount;
	short num033, num050, num060, num100;
	static short intl_fee_table1[] =   // rate @ 2006/Jan.
		{ 63,90,115,140,170,195,220,250,325,395,465,530,600,670,740,805,875,945,1015,1090,1165,1240 };
	static short intl_fee_table2[] =   // rate @ 2006/Jan.
		{ 63,90,130,175,215,260,300,345,420,545,665,785,905,1030,1155,1280,1405,1535,1665,1795,1930,2060 };
	static short intl_fee_table3[] =   // rate @ 2006/Jan.
		{ 84,170,255,335,420,505,590,675,795,915,1040,1160,1280,1400,1530,1655,1780,1910,2040,2170,2305,2435 };
	static short intl_fee_table4[] =   // rate @ 2006/Jan.
		{ 84,180,275,370,465,560,655,750,885,1020,1160,1295,1435,1570,1715,1855,1995,2140,2285,2435,2580,2730 };
	static short intl_fee_table5[] =   // rate @ 2006/Jan.
		{ 84,165,240,320,400,480,560,640,805,975,1145,1310,1480,1650,1830,2010,2185,2365,2550,2735,2920,3105 };
	
	getOptionStatus();
	
	textpointer = FldGetTextPtr(fieldptr_text);
	textlength = FldGetTextLength(fieldptr_text);
	if (textlength) {
		number = 0;
		pointpos = -1;
		
		/* convert from the inputted text to the weight number */
		for (textpos = 0; textpos < textlength; textpos ++) {
			textchar = textpointer[textpos];
			if ( textchar > 0x2f && textchar < 0x3a )
					number = number * 10 + textchar - 0x30;
			else if ( textchar == '.' && pointpos == -1)
					pointpos = textpos;
			else {
					FrmAlert(ErrorinvalidstringsAlert);
					return;
			}
		}
		if( pointpos > 4 || (pointpos == -1 && textlength > 4)) {
			FrmAlert(ErrorlargerstringsAlert);
			return;
		}
		
		if( pointpos == -1 )
			number = number * 1000;
		else if( textlength - pointpos > 4)
			number = number / ipower( 10, textlength - pointpos - 4 );
		else
			number = number * ipower( 10, (3 - (textlength - pointpos - 1)) );
		
		/* convert the inputted number to the weight score */
		/*   ~ 0.5oz -> weight = 0, ~ 1.0oz -> weight = 1, .... */
		if( list_unit == 0 ) {	/* gram */
			weight_oz = number / 14175;		/* 1 oz = 28.350 g */
			if( number % 14175 == 0 && number != 0) 
				weight_oz --;
		} else {				/* oz */
			weight_oz = number / 500;
			if( number % 500 == 0 && number != 0) 
				weight_oz --;
		}
		
		/* check the max. number of weight score */
		if( weight_oz > (128 - 1) && !(list_dest == USA)) {	/* max weight is 64 oz for intl. */
			FrmAlert(Errorover64ozAlert);
			return;
		}
		if( weight_oz > (26 - 1) && list_dest == USA) {	/* max weight is 13 oz for USA */
			FrmAlert(Errorover11ozAlert);
			return;
		}
		
		/* calcurate the postage charge from weight score */
		if( list_dest == USA ) {		// case of USA
			// amount = 37 + ((weight_oz / 2) * 23);	// Rate @ 2001/Jul.
			amount = 39 + ((weight_oz / 2) * 24);	// Rate @ 2006/Jan.
		}
		else if( list_dest >= AUSTRALIA && list_dest <= NEWZEALAND) {
										// case of Japan, Australia and New Zealand (Group 4)
			if( weight_oz < 16 ) {		/* if weight <= 8 oz */
				amount = intl_fee_table4[ (weight_oz / 2) ];
			} else if( weight_oz < 128 ) {	/* if weight <= 64 oz */
				amount = intl_fee_table4[ ((weight_oz - 16) / 8) + 8 ];
			} else {
				amount = 0; // soft bug
			}
		}
		else if( list_dest == CANADA) {	// case of Canada (Group 1)
			if( weight_oz < 16 ) {		/* if weight <= 8 oz */
				amount = intl_fee_table1[ (weight_oz / 2) ];
			} else if( weight_oz < 128 ) {	/* if weight <= 64 oz */
				amount = intl_fee_table1[ ((weight_oz - 16) / 8) + 8 ];
			} else {
				amount = 0; // soft bug
			}
		}
		else if( list_dest == MEXICO) {	// case of Mexico (Group 2)
			if( weight_oz < 16 ) {		/* if weight <= 8 oz */
				amount = intl_fee_table2[ (weight_oz / 2) ];
			} else if( weight_oz < 128 ) {	/* if weight <= 64 oz */
				amount = intl_fee_table2[ ((weight_oz - 16) / 8) + 8 ];
			} else {
				amount = 0; // soft bug
			}
		}
		else if( list_dest >= BELGIUM && list_dest <= UNITEDKINGDOM) {
										// case of EU countries (Group 3)
			if( weight_oz < 16 ) {		/* if weight <= 8 oz */
				amount = intl_fee_table3[ (weight_oz / 2) ];
			} else if( weight_oz < 128 ) {	/* if weight <= 64 oz */
				amount = intl_fee_table3[ ((weight_oz - 16) / 8) + 8 ];
			} else {
				amount = 0; // soft bug
			}
		}

		else if( list_dest == OTHER ) {
										// case of other countries (Group 5)
			if( weight_oz < 16 ) {		/* if weight <= 8 oz */
				amount = intl_fee_table5[ (weight_oz / 2) ];
			} else if( weight_oz < 128 ) {	/* if weight <= 64 oz */
				amount = intl_fee_table5[ ((weight_oz - 16) / 8) + 8 ];
			} else {
				amount = 0; // soft bug
			}
		}
		else {	// due to program's bug
			amount = 0;
		}
		
		hideButton();
		StrCopy( hex, conv_daller( amount ));
		
		/* calcurate the optimized stamps amount */
		total_amount = calcStampNumber( amount, &num033, &num050, &num060, &num100 );
		setStampNumber( num033, num050, num060, num100 );
		
		/* put the optimized stamps amount */
		//total_amount = num033 * 33 + num050 * 50 + num060 * 60 + num100 * 100;
		if( total_amount > 0 ) {
			StrCopy( totalbuf, conv_daller( total_amount ));
		} else {
			StrCopy( totalbuf, "---");
		}
		
		/* display refresh */
		FldSetTextPtr(fieldptr_hex, hex);
		FldRecalculateField(fieldptr_hex, true);
		
		FldSetTextPtr(fieldptr_total, totalbuf);
		FldRecalculateField(fieldptr_total, true);
		
		showButton();
		FrmDrawForm(FrmGetActiveForm());
		FldSetSelection( fieldptr_text, 0, StrLen( FldGetTextPtr(fieldptr_text) ));
	}
	else
	{
		FrmAlert(ErrornullstringsAlert);
	}
}

void hideButton( void )
{
	FormPtr form;
	form = FrmGetActiveForm();
	FrmHideObject( form, FrmGetObjectIndex( form, stampsButtonID_convertButton ));
	FrmShowObject( form, FrmGetObjectIndex( form, stampsButtonDummyButton ));
	FrmDrawForm( form );
}

void showButton( void )
{
	FormPtr form;
	form = FrmGetActiveForm();
	FrmHideObject( form, FrmGetObjectIndex( form, stampsButtonDummyButton ));
	FrmShowObject( form, FrmGetObjectIndex( form, stampsButtonID_convertButton ));
	FrmDrawForm( form );
}

static void setStampNumber( short num033, short num050, short num060, short num100 )
{
	FormPtr form;
	FieldPtr fieldptr;
	static char buf033[10],buf050[10],buf060[10],buf100[10];
	
	form = FrmGetActiveForm();
	
	fieldptr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_033Field));
	if( ! checkbox_033 ) {
		StrCopy( buf033, "-" );
	} else if( num033 > MaxUseStamps ) {
		StrCopy( buf033, "over" );
	} else {
		StrIToA( buf033, num033 );
	}
	FldSetTextPtr( fieldptr, buf033 );

	fieldptr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_050Field));
	if( ! checkbox_050 ) {
		StrCopy( buf050, "-" );
	} else if( num050 > MaxUseStamps ) {
		StrCopy( buf050, "over" );
	} else {
		StrIToA( buf050, num050 );
	}
	FldSetTextPtr( fieldptr, buf050 );
	
	fieldptr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_060Field));
	if( ! checkbox_060 ) {
		StrCopy( buf060, "-" );
	} else if( num060 > MaxUseStamps ) {
		StrCopy( buf060, "over" );
	} else {
		StrIToA( buf060, num060 );
	}
	FldSetTextPtr( fieldptr, buf060 );
	
	fieldptr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsFieldID_100Field));
	if( ! checkbox_100 ) {
		StrCopy( buf100, "-" );
	} else if( num100 > MaxUseStamps ) {
		StrCopy( buf100, "over" );
	} else {
		StrIToA( buf100, num100 );
	}
	FldSetTextPtr( fieldptr, buf100 );
	
	FldRecalculateField(fieldptr, true);
	return;
}

static void getOptionStatus( void )
{
 	FormPtr   form;

	form = FrmGetActiveForm();
	
	checkbox_033 = FrmGetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_033Checkbox) );
	checkbox_050 = FrmGetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_050Checkbox) );
	checkbox_060 = FrmGetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_060Checkbox) );
	checkbox_100 = FrmGetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_100Checkbox) );
	
	list_unit = LstGetSelection( FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsPopuplistID_unitList)));
	list_dest = LstGetSelection( FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsPopuplistID_destList)));
		
	return;
}

static void setOptionStatus( void )
{
 	FormPtr   form;
 	void *objPtr;

	form = FrmGetActiveForm();
	
	FrmSetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_033Checkbox), checkbox_033 );
	FrmSetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_050Checkbox), checkbox_050 );
	FrmSetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_060Checkbox), checkbox_060 );
	FrmSetControlValue( form, FrmGetObjectIndex(form, stampsCheckboxID_100Checkbox), checkbox_100 );

	objPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsPopuplistID_unitList));
	LstSetSelection( objPtr, list_unit);
	FrmCopyLabel(form, stampsPopupID_unitPopTrigger, 
		LstGetSelectionText( objPtr, list_unit) );

	objPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsPopuplistID_destList));
	LstSetSelection( objPtr, list_dest);
	FrmCopyLabel(form, stampsPopupID_destPopTrigger, 
		LstGetSelectionText( objPtr, list_dest) );

	objPtr = FrmGetObjectPtr(form, FrmGetObjectIndex(form, stampsListOfStampsList));
	LstSetSelection( objPtr, list_033);
	FrmCopyLabel(form, stampsPopup033PopTrigger, 
		LstGetSelectionText( objPtr, list_033) );
	LstSetSelection( objPtr, list_050);
	FrmCopyLabel(form, stampsPopup050PopTrigger, 
		LstGetSelectionText( objPtr, list_050) );
	LstSetSelection( objPtr, list_060);
	FrmCopyLabel(form, stampsPopup060PopTrigger, 
		LstGetSelectionText( objPtr, list_060) );
	LstSetSelection( objPtr, list_100);
	FrmCopyLabel(form, stampsPopup100PopTrigger, 
		LstGetSelectionText( objPtr, list_100) );

	return;
}

static long int ipower( int base, int pow )
{
	int count;
	long int result;
	result = 1;
	for( count = 0 ; count < pow ; count ++ )
		result = result * base;
	return result;
}

static char *conv_daller( int amount )
{
	static char buf[10];
	char tmpbuf[10];
	
	StrCopy( buf, "$");
	StrCat( buf, StrIToA( convbuf, amount / 100 ));
	StrCat( buf, "." );
		StrIToA( tmpbuf, amount % 100 );
	if( StrLen( tmpbuf ) == 1 ) {
		StrCat( buf, "0" );
		StrCat( buf, tmpbuf );
	} else {
		StrCat( buf, tmpbuf );
	}
	return buf;
}

static void swap( short *p, short *q )
{
	short tmp;
	
	tmp = *p;
	*p = *q;
	*q = tmp;
}

static short calcStampNumber( int amount, 
				short *num033, short *num050, short *num060, short *num100 )
{
	short c033, c050, c060, c100;
	short u033, u050, u060, u100;
	short amnt, good_amnt;
	short x0 = 33, x1 = 50, x2 = 60, x3 = 100;
	short min, min_p;
	int total_amount;
	
	x0 = popup_stamps[list_033];
	x1 = popup_stamps[list_050];
	x2 = popup_stamps[list_060];
	x3 = popup_stamps[list_100];
	
	u033 = checkbox_033 * x0;
	u050 = checkbox_050 * x1;
	u060 = checkbox_060 * x2;
	u100 = checkbox_100 * x3;

	min = x0;
	min_p = 0;
	if( min > x1 ) {
		min = x1;
		min_p = 1;
	} else if( min > x2 ) {
		min = x2;
		min_p = 2;
	} else if( min > x3 ) {
		min = x3;
		min_p = 3;
	}
	switch( min_p ) {
	case 0:	break;
	case 1:	swap( &x1, &x0 );
			swap( &u050, &u033 );
			swap( num050, num033 );
			break;
	case 2:	swap( &x2, &x0 );
			swap( &u060, &u033 );
			swap( num060, num033 );
			break;
	case 3:	swap( &x3, &x0 );
			swap( &u100, &u033 );
			swap( num100, num033 );
			break;
	}
	
	if( checkbox_033 + checkbox_050 + checkbox_060 + checkbox_100 == 0 ) {
		/* if no checkboxes are checked, calculation should be canceled. */
		*num033 = *num050 = *num060 = *num100 = 0;
		
	} else if( amount > 1200 ) {	// amount is too much, so we can't put all stamps on envelop
		FrmAlert(WarningtoomuchamountAlert);
		*num033 = *num050 = *num060 = *num100 = 0;
		
	} else {
		good_amnt = *num033 = *num050 = *num060 = *num100 = 9999;	/* initial largest number */
		
		amnt = 0;
		for( c100 = 0 ; (c100 <= ((amount /  x3) + 1) * (u100 ? 1 : 0)) && c100 <= MaxUseStamps ; c100 ++ ) {
			amnt += c100 * u100;
			if( amnt >= amount ) {
				checkAmount( amnt, &good_amnt, 0, 0, 0, c100, 
								num033, num050, num060, num100 );
				amnt -= c100 * u100;
				break;
			}
			for( c060 = 0 ; (c060 <= ((amount /  x2) + 1) * (u060 ? 1 : 0)) && c060 <= MaxUseStamps ; c060 ++ ) {
				amnt += c060 * u060;
				if( amnt >= amount ) {
					checkAmount( amnt, &good_amnt, 0, 0, c060, c100, 
									num033, num050, num060, num100 );
					amnt -= c060 * u060;
					break;
				}
				if( u033 == 0 ) {
					if( u050 != 0 ) {
						c050 = ((amount - amnt) % x1 == 0) ? 
								(amount - amnt) / x1 : (amount - amnt) / x1 + 1;
						amnt += c050 * u050;
						checkAmount( amnt, &good_amnt, 0, c050, c060, c100, 
										num033, num050, num060, num100 );
						amnt -= c050 * u050;
					}
				} else {
					for( c050 = 0 ; (c050 <= ((amount /  x1) + 1) * (u050 ? 1 : 0)) && c050 <= MaxUseStamps ; c050 ++ ) {
						amnt += c050 * u050;
						if( amnt >= amount ) {
							checkAmount( amnt, &good_amnt, 0, c050, c060, c100, 
											num033, num050, num060, num100 );
							amnt -= c050 * u050;
							break;
						}
						
						if( u033 != 0 ) {
							short tmp;
							tmp = (amount - amnt) / x0;
							c033 = (tmp * x0 == amount - amnt) ? tmp : tmp + 1;
							if( c033 <= MaxUseStamps ) {
						//for( c100 = 0 ; c100 <= ((amount / x3) + 1) * (u100 ? 1 : 0) ; c100 ++ ) {
							amnt += c033 * u033;
							//if( amnt >= amount ) {
								checkAmount( amnt, &good_amnt, c033, c050, c060, c100, 
												num033, num050, num060, num100 );
								//amnt -= c100 * u100;
								//break;
							//}
							amnt -= c033 * u033;
							}
						//}
						}
						amnt -= c050 * u050;
					}
				}
				amnt -= c060 * u060;
			}
			amnt -= c100 * u100;
		}
	}
	switch( min_p ) {
	case 0:	break;
	case 1:	swap( &x1, &x0 );
			swap( &u050, &u033 );
			swap( num050, num033 );
			break;
	case 2:	swap( &x2, &x0 );
			swap( &u060, &u033 );
			swap( num060, num033 );
			break;
	case 3:	swap( &x3, &x0 );
			swap( &u100, &u033 );
			swap( num100, num033 );
			break;
	}
	if( *num033 > MaxUseStamps || *num050 > MaxUseStamps || 
		*num060 > MaxUseStamps || *num100 > MaxUseStamps ) {
			total_amount = -1;
	} else {
		total_amount = *num033 * u033 + *num050 * u050 + *num060 * u060 + *num100 * u100;
	}
	return total_amount;
}

void checkAmount( short amnt, short *good_amnt, 
				short c033, short c050, short c060, short c100,
				short *num033, short *num050, short *num060, short *num100 )
{
	if( amnt < *good_amnt ) {
		*good_amnt = amnt;
		*num033 = c033;
		*num050 = c050;
		*num060 = c060;
		*num100 = c100;
	} else if( amnt == *good_amnt &&
			 (c033 + c050 + c060 + c100) < (*num033 + *num050 + *num060 + *num100) ) {
		*num033 = c033;
		*num050 = c050;
		*num060 = c060;
		*num100 = c100;
	}
	return;
}
